#include "python_functions.h"

// @generated from tools/autograd/templates/python_functions.cpp

#include <Python.h>
#include <ATen/ATen.h>

#include "Functions.h"
#include "torch/csrc/autograd/python_cpp_function.h"

namespace torch { namespace autograd { namespace generated {

template<typename C>
static void addClass(PyTypeObject& type, const char* name,
  PyGetSetDef* function_properties=NULL, PyMethodDef* function_methods=NULL)
{
  _initFunctionPyTypeObject(type, name, function_properties, function_methods);
  Py_INCREF(&type);
  registerCppFunction(typeid(C), &type);
}

void initialize_autogenerated_functions() {
  static PyTypeObject AbsBackwardClass;
  addClass<AbsBackward>(AbsBackwardClass, "AbsBackward");
  static PyTypeObject AcosBackwardClass;
  addClass<AcosBackward>(AcosBackwardClass, "AcosBackward");
  static PyTypeObject AddBackwardClass;
  addClass<AddBackward>(AddBackwardClass, "AddBackward");
  static PyTypeObject SNativeAddBackwardClass;
  addClass<SNativeAddBackward>(SNativeAddBackwardClass, "SNativeAddBackward");
  static PyTypeObject ThAddBackwardClass;
  addClass<ThAddBackward>(ThAddBackwardClass, "ThAddBackward");
  static PyTypeObject AddbmmBackwardClass;
  addClass<AddbmmBackward>(AddbmmBackwardClass, "AddbmmBackward");
  static PyTypeObject AddcdivBackwardClass;
  addClass<AddcdivBackward>(AddcdivBackwardClass, "AddcdivBackward");
  static PyTypeObject AddcmulBackwardClass;
  addClass<AddcmulBackward>(AddcmulBackwardClass, "AddcmulBackward");
  static PyTypeObject ThAddmmBackwardClass;
  addClass<ThAddmmBackward>(ThAddmmBackwardClass, "ThAddmmBackward");
  static PyTypeObject SNativeAddmmBackwardClass;
  addClass<SNativeAddmmBackward>(SNativeAddmmBackwardClass, "SNativeAddmmBackward");
  static PyTypeObject AddmvBackwardClass;
  addClass<AddmvBackward>(AddmvBackwardClass, "AddmvBackward");
  static PyTypeObject AddrBackwardClass;
  addClass<AddrBackward>(AddrBackwardClass, "AddrBackward");
  static PyTypeObject AliasBackwardClass;
  addClass<AliasBackward>(AliasBackwardClass, "AliasBackward");
  static PyTypeObject AsStridedBackwardClass;
  addClass<AsStridedBackward>(AsStridedBackwardClass, "AsStridedBackward");
  static PyTypeObject AsinBackwardClass;
  addClass<AsinBackward>(AsinBackwardClass, "AsinBackward");
  static PyTypeObject AtanBackwardClass;
  addClass<AtanBackward>(AtanBackwardClass, "AtanBackward");
  static PyTypeObject Atan2BackwardClass;
  addClass<Atan2Backward>(Atan2BackwardClass, "Atan2Backward");
  static PyTypeObject BaddbmmBackwardClass;
  addClass<BaddbmmBackward>(BaddbmmBackwardClass, "BaddbmmBackward");
  static PyTypeObject BernoulliBackwardClass;
  addClass<BernoulliBackward>(BernoulliBackwardClass, "BernoulliBackward");
  static PyTypeObject BmmBackwardClass;
  addClass<BmmBackward>(BmmBackwardClass, "BmmBackward");
  static PyTypeObject BtrifactBackwardClass;
  addClass<BtrifactBackward>(BtrifactBackwardClass, "BtrifactBackward");
  static PyTypeObject BtrifactWithInfoBackwardClass;
  addClass<BtrifactWithInfoBackward>(BtrifactWithInfoBackwardClass, "BtrifactWithInfoBackward");
  static PyTypeObject BtrisolveBackwardClass;
  addClass<BtrisolveBackward>(BtrisolveBackwardClass, "BtrisolveBackward");
  static PyTypeObject CatBackwardClass;
  addClass<CatBackward>(CatBackwardClass, "CatBackward");
  static PyTypeObject CauchyBackwardClass;
  addClass<CauchyBackward>(CauchyBackwardClass, "CauchyBackward");
  static PyTypeObject CeilBackwardClass;
  addClass<CeilBackward>(CeilBackwardClass, "CeilBackward");
  static PyTypeObject ClampBackwardClass;
  addClass<ClampBackward>(ClampBackwardClass, "ClampBackward");
  static PyTypeObject ClampMinBackwardClass;
  addClass<ClampMinBackward>(ClampMinBackwardClass, "ClampMinBackward");
  static PyTypeObject ClampMaxBackwardClass;
  addClass<ClampMaxBackward>(ClampMaxBackwardClass, "ClampMaxBackward");
  static PyTypeObject CloneBackwardClass;
  addClass<CloneBackward>(CloneBackwardClass, "CloneBackward");
  static PyTypeObject CosBackwardClass;
  addClass<CosBackward>(CosBackwardClass, "CosBackward");
  static PyTypeObject CoshBackwardClass;
  addClass<CoshBackward>(CoshBackwardClass, "CoshBackward");
  static PyTypeObject CrossBackwardClass;
  addClass<CrossBackward>(CrossBackwardClass, "CrossBackward");
  static PyTypeObject CumprodBackwardClass;
  addClass<CumprodBackward>(CumprodBackwardClass, "CumprodBackward");
  static PyTypeObject CumsumBackwardClass;
  addClass<CumsumBackward>(CumsumBackwardClass, "CumsumBackward");
  static PyTypeObject ConvTbcBackwardClass;
  addClass<ConvTbcBackward>(ConvTbcBackwardClass, "ConvTbcBackward");
  static PyTypeObject DetBackwardClass;
  addClass<DetBackward>(DetBackwardClass, "DetBackward");
  static PyTypeObject DiagBackwardClass;
  addClass<DiagBackward>(DiagBackwardClass, "DiagBackward");
  static PyTypeObject DiagonalBackwardClass;
  addClass<DiagonalBackward>(DiagonalBackwardClass, "DiagonalBackward");
  static PyTypeObject DistBackwardClass;
  addClass<DistBackward>(DistBackwardClass, "DistBackward");
  static PyTypeObject DivBackward0Class;
  addClass<DivBackward0>(DivBackward0Class, "DivBackward0");
  static PyTypeObject DivBackward1Class;
  addClass<DivBackward1>(DivBackward1Class, "DivBackward1");
  static PyTypeObject DotBackwardClass;
  addClass<DotBackward>(DotBackwardClass, "DotBackward");
  static PyTypeObject EigBackwardClass;
  addClass<EigBackward>(EigBackwardClass, "EigBackward");
  static PyTypeObject EqBackward0Class;
  addClass<EqBackward0>(EqBackward0Class, "EqBackward0");
  static PyTypeObject EqBackward1Class;
  addClass<EqBackward1>(EqBackward1Class, "EqBackward1");
  static PyTypeObject ErfBackwardClass;
  addClass<ErfBackward>(ErfBackwardClass, "ErfBackward");
  static PyTypeObject ErfinvBackwardClass;
  addClass<ErfinvBackward>(ErfinvBackwardClass, "ErfinvBackward");
  static PyTypeObject ExpBackwardClass;
  addClass<ExpBackward>(ExpBackwardClass, "ExpBackward");
  static PyTypeObject Expm1BackwardClass;
  addClass<Expm1Backward>(Expm1BackwardClass, "Expm1Backward");
  static PyTypeObject ExpandBackwardClass;
  addClass<ExpandBackward>(ExpandBackwardClass, "ExpandBackward");
  static PyTypeObject ExponentialBackwardClass;
  addClass<ExponentialBackward>(ExponentialBackwardClass, "ExponentialBackward");
  static PyTypeObject FillBackward0Class;
  addClass<FillBackward0>(FillBackward0Class, "FillBackward0");
  static PyTypeObject FillBackward1Class;
  addClass<FillBackward1>(FillBackward1Class, "FillBackward1");
  static PyTypeObject FloorBackwardClass;
  addClass<FloorBackward>(FloorBackwardClass, "FloorBackward");
  static PyTypeObject FmodBackward0Class;
  addClass<FmodBackward0>(FmodBackward0Class, "FmodBackward0");
  static PyTypeObject FmodBackward1Class;
  addClass<FmodBackward1>(FmodBackward1Class, "FmodBackward1");
  static PyTypeObject FracBackwardClass;
  addClass<FracBackward>(FracBackwardClass, "FracBackward");
  static PyTypeObject GatherBackwardClass;
  addClass<GatherBackward>(GatherBackwardClass, "GatherBackward");
  static PyTypeObject GeBackward0Class;
  addClass<GeBackward0>(GeBackward0Class, "GeBackward0");
  static PyTypeObject GeBackward1Class;
  addClass<GeBackward1>(GeBackward1Class, "GeBackward1");
  static PyTypeObject GelsBackwardClass;
  addClass<GelsBackward>(GelsBackwardClass, "GelsBackward");
  static PyTypeObject GeometricBackwardClass;
  addClass<GeometricBackward>(GeometricBackwardClass, "GeometricBackward");
  static PyTypeObject GeqrfBackwardClass;
  addClass<GeqrfBackward>(GeqrfBackwardClass, "GeqrfBackward");
  static PyTypeObject GerBackwardClass;
  addClass<GerBackward>(GerBackwardClass, "GerBackward");
  static PyTypeObject GesvSingleBackwardClass;
  addClass<GesvSingleBackward>(GesvSingleBackwardClass, "GesvSingleBackward");
  static PyTypeObject GesvHelperBackwardClass;
  addClass<GesvHelperBackward>(GesvHelperBackwardClass, "GesvHelperBackward");
  static PyTypeObject GtBackward0Class;
  addClass<GtBackward0>(GtBackward0Class, "GtBackward0");
  static PyTypeObject GtBackward1Class;
  addClass<GtBackward1>(GtBackward1Class, "GtBackward1");
  static PyTypeObject HistcBackwardClass;
  addClass<HistcBackward>(HistcBackwardClass, "HistcBackward");
  static PyTypeObject IndexAddBackwardClass;
  addClass<IndexAddBackward>(IndexAddBackwardClass, "IndexAddBackward");
  static PyTypeObject IndexCopyBackwardClass;
  addClass<IndexCopyBackward>(IndexCopyBackwardClass, "IndexCopyBackward");
  static PyTypeObject IndexFillBackward0Class;
  addClass<IndexFillBackward0>(IndexFillBackward0Class, "IndexFillBackward0");
  static PyTypeObject IndexFillBackward1Class;
  addClass<IndexFillBackward1>(IndexFillBackward1Class, "IndexFillBackward1");
  static PyTypeObject IndexSelectBackwardClass;
  addClass<IndexSelectBackward>(IndexSelectBackwardClass, "IndexSelectBackward");
  static PyTypeObject InverseBackwardClass;
  addClass<InverseBackward>(InverseBackwardClass, "InverseBackward");
  static PyTypeObject KthvalueBackwardClass;
  addClass<KthvalueBackward>(KthvalueBackwardClass, "KthvalueBackward");
  static PyTypeObject LeBackward0Class;
  addClass<LeBackward0>(LeBackward0Class, "LeBackward0");
  static PyTypeObject LeBackward1Class;
  addClass<LeBackward1>(LeBackward1Class, "LeBackward1");
  static PyTypeObject LerpBackwardClass;
  addClass<LerpBackward>(LerpBackwardClass, "LerpBackward");
  static PyTypeObject LgammaBackwardClass;
  addClass<LgammaBackward>(LgammaBackwardClass, "LgammaBackward");
  static PyTypeObject DigammaBackwardClass;
  addClass<DigammaBackward>(DigammaBackwardClass, "DigammaBackward");
  static PyTypeObject PolygammaBackwardClass;
  addClass<PolygammaBackward>(PolygammaBackwardClass, "PolygammaBackward");
  static PyTypeObject LogBackwardClass;
  addClass<LogBackward>(LogBackwardClass, "LogBackward");
  static PyTypeObject Log10BackwardClass;
  addClass<Log10Backward>(Log10BackwardClass, "Log10Backward");
  static PyTypeObject Log1PBackwardClass;
  addClass<Log1PBackward>(Log1PBackwardClass, "Log1PBackward");
  static PyTypeObject Log2BackwardClass;
  addClass<Log2Backward>(Log2BackwardClass, "Log2Backward");
  static PyTypeObject LogdetBackwardClass;
  addClass<LogdetBackward>(LogdetBackwardClass, "LogdetBackward");
  static PyTypeObject LogNormalBackwardClass;
  addClass<LogNormalBackward>(LogNormalBackwardClass, "LogNormalBackward");
  static PyTypeObject LogsumexpBackwardClass;
  addClass<LogsumexpBackward>(LogsumexpBackwardClass, "LogsumexpBackward");
  static PyTypeObject LtBackward0Class;
  addClass<LtBackward0>(LtBackward0Class, "LtBackward0");
  static PyTypeObject LtBackward1Class;
  addClass<LtBackward1>(LtBackward1Class, "LtBackward1");
  static PyTypeObject MaskedFillBackward0Class;
  addClass<MaskedFillBackward0>(MaskedFillBackward0Class, "MaskedFillBackward0");
  static PyTypeObject MaskedFillBackward1Class;
  addClass<MaskedFillBackward1>(MaskedFillBackward1Class, "MaskedFillBackward1");
  static PyTypeObject MaskedScatterBackwardClass;
  addClass<MaskedScatterBackward>(MaskedScatterBackwardClass, "MaskedScatterBackward");
  static PyTypeObject MaskedSelectBackwardClass;
  addClass<MaskedSelectBackward>(MaskedSelectBackwardClass, "MaskedSelectBackward");
  static PyTypeObject MaxBackward0Class;
  addClass<MaxBackward0>(MaxBackward0Class, "MaxBackward0");
  static PyTypeObject MaxBackward1Class;
  addClass<MaxBackward1>(MaxBackward1Class, "MaxBackward1");
  static PyTypeObject MaxBackward2Class;
  addClass<MaxBackward2>(MaxBackward2Class, "MaxBackward2");
  static PyTypeObject MeanBackward0Class;
  addClass<MeanBackward0>(MeanBackward0Class, "MeanBackward0");
  static PyTypeObject MeanBackward1Class;
  addClass<MeanBackward1>(MeanBackward1Class, "MeanBackward1");
  static PyTypeObject MedianBackward0Class;
  addClass<MedianBackward0>(MedianBackward0Class, "MedianBackward0");
  static PyTypeObject MedianBackward1Class;
  addClass<MedianBackward1>(MedianBackward1Class, "MedianBackward1");
  static PyTypeObject MinBackward0Class;
  addClass<MinBackward0>(MinBackward0Class, "MinBackward0");
  static PyTypeObject MinBackward1Class;
  addClass<MinBackward1>(MinBackward1Class, "MinBackward1");
  static PyTypeObject MinBackward2Class;
  addClass<MinBackward2>(MinBackward2Class, "MinBackward2");
  static PyTypeObject MmBackwardClass;
  addClass<MmBackward>(MmBackwardClass, "MmBackward");
  static PyTypeObject ModeBackwardClass;
  addClass<ModeBackward>(ModeBackwardClass, "ModeBackward");
  static PyTypeObject MulBackwardClass;
  addClass<MulBackward>(MulBackwardClass, "MulBackward");
  static PyTypeObject SNativeMulBackwardClass;
  addClass<SNativeMulBackward>(SNativeMulBackwardClass, "SNativeMulBackward");
  static PyTypeObject ThMulBackwardClass;
  addClass<ThMulBackward>(ThMulBackwardClass, "ThMulBackward");
  static PyTypeObject MvBackwardClass;
  addClass<MvBackward>(MvBackwardClass, "MvBackward");
  static PyTypeObject NeBackward0Class;
  addClass<NeBackward0>(NeBackward0Class, "NeBackward0");
  static PyTypeObject NeBackward1Class;
  addClass<NeBackward1>(NeBackward1Class, "NeBackward1");
  static PyTypeObject NegBackwardClass;
  addClass<NegBackward>(NegBackwardClass, "NegBackward");
  static PyTypeObject NormBackward0Class;
  addClass<NormBackward0>(NormBackward0Class, "NormBackward0");
  static PyTypeObject NormBackward1Class;
  addClass<NormBackward1>(NormBackward1Class, "NormBackward1");
  static PyTypeObject NormalBackward0Class;
  addClass<NormalBackward0>(NormalBackward0Class, "NormalBackward0");
  static PyTypeObject NormalBackward1Class;
  addClass<NormalBackward1>(NormalBackward1Class, "NormalBackward1");
  static PyTypeObject NormalBackward2Class;
  addClass<NormalBackward2>(NormalBackward2Class, "NormalBackward2");
  static PyTypeObject NormalBackward3Class;
  addClass<NormalBackward3>(NormalBackward3Class, "NormalBackward3");
  static PyTypeObject OrgqrBackwardClass;
  addClass<OrgqrBackward>(OrgqrBackwardClass, "OrgqrBackward");
  static PyTypeObject OrmqrBackwardClass;
  addClass<OrmqrBackward>(OrmqrBackwardClass, "OrmqrBackward");
  static PyTypeObject PermuteBackwardClass;
  addClass<PermuteBackward>(PermuteBackwardClass, "PermuteBackward");
  static PyTypeObject PoissonBackwardClass;
  addClass<PoissonBackward>(PoissonBackwardClass, "PoissonBackward");
  static PyTypeObject PotrfBackwardClass;
  addClass<PotrfBackward>(PotrfBackwardClass, "PotrfBackward");
  static PyTypeObject PotriBackwardClass;
  addClass<PotriBackward>(PotriBackwardClass, "PotriBackward");
  static PyTypeObject PotrsBackwardClass;
  addClass<PotrsBackward>(PotrsBackwardClass, "PotrsBackward");
  static PyTypeObject PowBackward0Class;
  addClass<PowBackward0>(PowBackward0Class, "PowBackward0");
  static PyTypeObject PowBackward1Class;
  addClass<PowBackward1>(PowBackward1Class, "PowBackward1");
  static PyTypeObject ProdBackward0Class;
  addClass<ProdBackward0>(ProdBackward0Class, "ProdBackward0");
  static PyTypeObject ProdBackward1Class;
  addClass<ProdBackward1>(ProdBackward1Class, "ProdBackward1");
  static PyTypeObject PstrfBackwardClass;
  addClass<PstrfBackward>(PstrfBackwardClass, "PstrfBackward");
  static PyTypeObject PutBackwardClass;
  addClass<PutBackward>(PutBackwardClass, "PutBackward");
  static PyTypeObject QrBackwardClass;
  addClass<QrBackward>(QrBackwardClass, "QrBackward");
  static PyTypeObject RandomBackward0Class;
  addClass<RandomBackward0>(RandomBackward0Class, "RandomBackward0");
  static PyTypeObject RandomBackward1Class;
  addClass<RandomBackward1>(RandomBackward1Class, "RandomBackward1");
  static PyTypeObject RandomBackward2Class;
  addClass<RandomBackward2>(RandomBackward2Class, "RandomBackward2");
  static PyTypeObject ReciprocalBackwardClass;
  addClass<ReciprocalBackward>(ReciprocalBackwardClass, "ReciprocalBackward");
  static PyTypeObject RemainderBackward0Class;
  addClass<RemainderBackward0>(RemainderBackward0Class, "RemainderBackward0");
  static PyTypeObject RemainderBackward1Class;
  addClass<RemainderBackward1>(RemainderBackward1Class, "RemainderBackward1");
  static PyTypeObject RenormBackwardClass;
  addClass<RenormBackward>(RenormBackwardClass, "RenormBackward");
  static PyTypeObject RepeatBackwardClass;
  addClass<RepeatBackward>(RepeatBackwardClass, "RepeatBackward");
  static PyTypeObject Roipooling2DBackwardClass;
  addClass<Roipooling2DBackward>(Roipooling2DBackwardClass, "Roipooling2DBackward");
  static PyTypeObject RoundBackwardClass;
  addClass<RoundBackward>(RoundBackwardClass, "RoundBackward");
  static PyTypeObject RsqrtBackwardClass;
  addClass<RsqrtBackward>(RsqrtBackwardClass, "RsqrtBackward");
  static PyTypeObject ScatterBackward0Class;
  addClass<ScatterBackward0>(ScatterBackward0Class, "ScatterBackward0");
  static PyTypeObject ScatterBackward1Class;
  addClass<ScatterBackward1>(ScatterBackward1Class, "ScatterBackward1");
  static PyTypeObject ScatterAddBackwardClass;
  addClass<ScatterAddBackward>(ScatterAddBackwardClass, "ScatterAddBackward");
  static PyTypeObject SelectBackwardClass;
  addClass<SelectBackward>(SelectBackwardClass, "SelectBackward");
  static PyTypeObject SigmoidBackwardClass;
  addClass<SigmoidBackward>(SigmoidBackwardClass, "SigmoidBackward");
  static PyTypeObject SignBackwardClass;
  addClass<SignBackward>(SignBackwardClass, "SignBackward");
  static PyTypeObject SinBackwardClass;
  addClass<SinBackward>(SinBackwardClass, "SinBackward");
  static PyTypeObject SinhBackwardClass;
  addClass<SinhBackward>(SinhBackwardClass, "SinhBackward");
  static PyTypeObject SliceBackwardClass;
  addClass<SliceBackward>(SliceBackwardClass, "SliceBackward");
  static PyTypeObject SlogdetBackwardClass;
  addClass<SlogdetBackward>(SlogdetBackwardClass, "SlogdetBackward");
  static PyTypeObject SortBackwardClass;
  addClass<SortBackward>(SortBackwardClass, "SortBackward");
  static PyTypeObject SplitBackwardClass;
  addClass<SplitBackward>(SplitBackwardClass, "SplitBackward");
  static PyTypeObject SplitWithSizesBackwardClass;
  addClass<SplitWithSizesBackward>(SplitWithSizesBackwardClass, "SplitWithSizesBackward");
  static PyTypeObject SqrtBackwardClass;
  addClass<SqrtBackward>(SqrtBackwardClass, "SqrtBackward");
  static PyTypeObject SqueezeBackward0Class;
  addClass<SqueezeBackward0>(SqueezeBackward0Class, "SqueezeBackward0");
  static PyTypeObject SqueezeBackward1Class;
  addClass<SqueezeBackward1>(SqueezeBackward1Class, "SqueezeBackward1");
  static PyTypeObject SqueezeBackward2Class;
  addClass<SqueezeBackward2>(SqueezeBackward2Class, "SqueezeBackward2");
  static PyTypeObject SqueezeBackward3Class;
  addClass<SqueezeBackward3>(SqueezeBackward3Class, "SqueezeBackward3");
  static PyTypeObject StdBackward0Class;
  addClass<StdBackward0>(StdBackward0Class, "StdBackward0");
  static PyTypeObject StdBackward1Class;
  addClass<StdBackward1>(StdBackward1Class, "StdBackward1");
  static PyTypeObject SubBackwardClass;
  addClass<SubBackward>(SubBackwardClass, "SubBackward");
  static PyTypeObject SNativeSubBackwardClass;
  addClass<SNativeSubBackward>(SNativeSubBackwardClass, "SNativeSubBackward");
  static PyTypeObject ThSubBackwardClass;
  addClass<ThSubBackward>(ThSubBackwardClass, "ThSubBackward");
  static PyTypeObject SumBackward0Class;
  addClass<SumBackward0>(SumBackward0Class, "SumBackward0");
  static PyTypeObject SumBackward1Class;
  addClass<SumBackward1>(SumBackward1Class, "SumBackward1");
  static PyTypeObject SvdBackwardClass;
  addClass<SvdBackward>(SvdBackwardClass, "SvdBackward");
  static PyTypeObject SymeigBackwardClass;
  addClass<SymeigBackward>(SymeigBackwardClass, "SymeigBackward");
  static PyTypeObject TBackwardClass;
  addClass<TBackward>(TBackwardClass, "TBackward");
  static PyTypeObject FlipBackwardClass;
  addClass<FlipBackward>(FlipBackwardClass, "FlipBackward");
  static PyTypeObject TakeBackwardClass;
  addClass<TakeBackward>(TakeBackwardClass, "TakeBackward");
  static PyTypeObject TanBackwardClass;
  addClass<TanBackward>(TanBackwardClass, "TanBackward");
  static PyTypeObject TanhBackwardClass;
  addClass<TanhBackward>(TanhBackwardClass, "TanhBackward");
  static PyTypeObject TopkBackwardClass;
  addClass<TopkBackward>(TopkBackwardClass, "TopkBackward");
  static PyTypeObject TraceBackwardClass;
  addClass<TraceBackward>(TraceBackwardClass, "TraceBackward");
  static PyTypeObject TransposeBackward0Class;
  addClass<TransposeBackward0>(TransposeBackward0Class, "TransposeBackward0");
  static PyTypeObject TransposeBackward1Class;
  addClass<TransposeBackward1>(TransposeBackward1Class, "TransposeBackward1");
  static PyTypeObject TrilBackwardClass;
  addClass<TrilBackward>(TrilBackwardClass, "TrilBackward");
  static PyTypeObject TriuBackwardClass;
  addClass<TriuBackward>(TriuBackwardClass, "TriuBackward");
  static PyTypeObject TrtrsBackwardClass;
  addClass<TrtrsBackward>(TrtrsBackwardClass, "TrtrsBackward");
  static PyTypeObject TruncBackwardClass;
  addClass<TruncBackward>(TruncBackwardClass, "TruncBackward");
  static PyTypeObject UnfoldBackwardClass;
  addClass<UnfoldBackward>(UnfoldBackwardClass, "UnfoldBackward");
  static PyTypeObject UniformBackwardClass;
  addClass<UniformBackward>(UniformBackwardClass, "UniformBackward");
  static PyTypeObject UniqueBackwardClass;
  addClass<UniqueBackward>(UniqueBackwardClass, "UniqueBackward");
  static PyTypeObject UnsafeViewBackwardClass;
  addClass<UnsafeViewBackward>(UnsafeViewBackwardClass, "UnsafeViewBackward");
  static PyTypeObject UnsqueezeBackward0Class;
  addClass<UnsqueezeBackward0>(UnsqueezeBackward0Class, "UnsqueezeBackward0");
  static PyTypeObject UnsqueezeBackward1Class;
  addClass<UnsqueezeBackward1>(UnsqueezeBackward1Class, "UnsqueezeBackward1");
  static PyTypeObject VarBackward0Class;
  addClass<VarBackward0>(VarBackward0Class, "VarBackward0");
  static PyTypeObject VarBackward1Class;
  addClass<VarBackward1>(VarBackward1Class, "VarBackward1");
  static PyTypeObject ViewBackwardClass;
  addClass<ViewBackward>(ViewBackwardClass, "ViewBackward");
  static PyTypeObject SWhereBackwardClass;
  addClass<SWhereBackward>(SWhereBackwardClass, "SWhereBackward");
  static PyTypeObject ZeroBackwardClass;
  addClass<ZeroBackward>(ZeroBackwardClass, "ZeroBackward");
  static PyTypeObject SparseMaskBackwardClass;
  addClass<SparseMaskBackward>(SparseMaskBackwardClass, "SparseMaskBackward");
  static PyTypeObject StandardGammaBackwardClass;
  addClass<StandardGammaBackward>(StandardGammaBackwardClass, "StandardGammaBackward");
  static PyTypeObject StandardGammaGradBackwardClass;
  addClass<StandardGammaGradBackward>(StandardGammaGradBackwardClass, "StandardGammaGradBackward");
  static PyTypeObject TrilinearBackwardClass;
  addClass<TrilinearBackward>(TrilinearBackwardClass, "TrilinearBackward");
  static PyTypeObject BinaryCrossEntropyBackwardClass;
  addClass<BinaryCrossEntropyBackward>(BinaryCrossEntropyBackwardClass, "BinaryCrossEntropyBackward");
  static PyTypeObject EmbeddingBackwardClass;
  addClass<EmbeddingBackward>(EmbeddingBackwardClass, "EmbeddingBackward");
  static PyTypeObject EmbeddingBagBackwardClass;
  addClass<EmbeddingBagBackward>(EmbeddingBagBackwardClass, "EmbeddingBagBackward");
  static PyTypeObject EmbeddingRenormBackwardClass;
  addClass<EmbeddingRenormBackward>(EmbeddingRenormBackwardClass, "EmbeddingRenormBackward");
  static PyTypeObject KlDivBackwardClass;
  addClass<KlDivBackward>(KlDivBackwardClass, "KlDivBackward");
  static PyTypeObject L1LossBackwardClass;
  addClass<L1LossBackward>(L1LossBackwardClass, "L1LossBackward");
  static PyTypeObject MseLossBackwardClass;
  addClass<MseLossBackward>(MseLossBackwardClass, "MseLossBackward");
  static PyTypeObject MultiMarginLossBackwardClass;
  addClass<MultiMarginLossBackward>(MultiMarginLossBackwardClass, "MultiMarginLossBackward");
  static PyTypeObject MultilabelMarginLossBackwardClass;
  addClass<MultilabelMarginLossBackward>(MultilabelMarginLossBackwardClass, "MultilabelMarginLossBackward");
  static PyTypeObject NllLossBackwardClass;
  addClass<NllLossBackward>(NllLossBackwardClass, "NllLossBackward");
  static PyTypeObject NllLoss2DBackwardClass;
  addClass<NllLoss2DBackward>(NllLoss2DBackwardClass, "NllLoss2DBackward");
  static PyTypeObject SmoothL1LossBackwardClass;
  addClass<SmoothL1LossBackward>(SmoothL1LossBackwardClass, "SmoothL1LossBackward");
  static PyTypeObject SoftMarginLossBackwardClass;
  addClass<SoftMarginLossBackward>(SoftMarginLossBackwardClass, "SoftMarginLossBackward");
  static PyTypeObject ReluBackwardClass;
  addClass<ReluBackward>(ReluBackwardClass, "ReluBackward");
  static PyTypeObject EluBackwardClass;
  addClass<EluBackward>(EluBackwardClass, "EluBackward");
  static PyTypeObject GluBackwardClass;
  addClass<GluBackward>(GluBackwardClass, "GluBackward");
  static PyTypeObject HardshrinkBackwardClass;
  addClass<HardshrinkBackward>(HardshrinkBackwardClass, "HardshrinkBackward");
  static PyTypeObject HardshrinkBackwardBackwardClass;
  addClass<HardshrinkBackwardBackward>(HardshrinkBackwardBackwardClass, "HardshrinkBackwardBackward");
  static PyTypeObject HardtanhBackward0Class;
  addClass<HardtanhBackward0>(HardtanhBackward0Class, "HardtanhBackward0");
  static PyTypeObject HardtanhBackward1Class;
  addClass<HardtanhBackward1>(HardtanhBackward1Class, "HardtanhBackward1");
  static PyTypeObject LeakyReluBackward0Class;
  addClass<LeakyReluBackward0>(LeakyReluBackward0Class, "LeakyReluBackward0");
  static PyTypeObject LeakyReluBackward1Class;
  addClass<LeakyReluBackward1>(LeakyReluBackward1Class, "LeakyReluBackward1");
  static PyTypeObject LogSigmoidBackwardClass;
  addClass<LogSigmoidBackward>(LogSigmoidBackwardClass, "LogSigmoidBackward");
  static PyTypeObject LogSoftmaxBackwardClass;
  addClass<LogSoftmaxBackward>(LogSoftmaxBackwardClass, "LogSoftmaxBackward");
  static PyTypeObject PreluBackwardClass;
  addClass<PreluBackward>(PreluBackwardClass, "PreluBackward");
  static PyTypeObject RreluWithNoiseBackward0Class;
  addClass<RreluWithNoiseBackward0>(RreluWithNoiseBackward0Class, "RreluWithNoiseBackward0");
  static PyTypeObject RreluWithNoiseBackward1Class;
  addClass<RreluWithNoiseBackward1>(RreluWithNoiseBackward1Class, "RreluWithNoiseBackward1");
  static PyTypeObject SoftmaxBackwardClass;
  addClass<SoftmaxBackward>(SoftmaxBackwardClass, "SoftmaxBackward");
  static PyTypeObject SoftplusBackwardClass;
  addClass<SoftplusBackward>(SoftplusBackwardClass, "SoftplusBackward");
  static PyTypeObject SoftshrinkBackwardClass;
  addClass<SoftshrinkBackward>(SoftshrinkBackwardClass, "SoftshrinkBackward");
  static PyTypeObject ThresholdBackward0Class;
  addClass<ThresholdBackward0>(ThresholdBackward0Class, "ThresholdBackward0");
  static PyTypeObject ThresholdBackward1Class;
  addClass<ThresholdBackward1>(ThresholdBackward1Class, "ThresholdBackward1");
  static PyTypeObject ReflectionPad1DBackwardClass;
  addClass<ReflectionPad1DBackward>(ReflectionPad1DBackwardClass, "ReflectionPad1DBackward");
  static PyTypeObject ReflectionPad2DBackwardClass;
  addClass<ReflectionPad2DBackward>(ReflectionPad2DBackwardClass, "ReflectionPad2DBackward");
  static PyTypeObject ReplicationPad1DBackwardClass;
  addClass<ReplicationPad1DBackward>(ReplicationPad1DBackwardClass, "ReplicationPad1DBackward");
  static PyTypeObject ReplicationPad2DBackwardClass;
  addClass<ReplicationPad2DBackward>(ReplicationPad2DBackwardClass, "ReplicationPad2DBackward");
  static PyTypeObject ReplicationPad3DBackwardClass;
  addClass<ReplicationPad3DBackward>(ReplicationPad3DBackwardClass, "ReplicationPad3DBackward");
  static PyTypeObject UpsampleLinear1DBackwardClass;
  addClass<UpsampleLinear1DBackward>(UpsampleLinear1DBackwardClass, "UpsampleLinear1DBackward");
  static PyTypeObject UpsampleBilinear2DBackwardClass;
  addClass<UpsampleBilinear2DBackward>(UpsampleBilinear2DBackwardClass, "UpsampleBilinear2DBackward");
  static PyTypeObject UpsampleTrilinear3DBackwardClass;
  addClass<UpsampleTrilinear3DBackward>(UpsampleTrilinear3DBackwardClass, "UpsampleTrilinear3DBackward");
  static PyTypeObject UpsampleNearest1DBackwardClass;
  addClass<UpsampleNearest1DBackward>(UpsampleNearest1DBackwardClass, "UpsampleNearest1DBackward");
  static PyTypeObject UpsampleNearest2DBackwardClass;
  addClass<UpsampleNearest2DBackward>(UpsampleNearest2DBackwardClass, "UpsampleNearest2DBackward");
  static PyTypeObject UpsampleNearest3DBackwardClass;
  addClass<UpsampleNearest3DBackward>(UpsampleNearest3DBackwardClass, "UpsampleNearest3DBackward");
  static PyTypeObject AdaptiveAvgPool2DBackwardClass;
  addClass<AdaptiveAvgPool2DBackward>(AdaptiveAvgPool2DBackwardClass, "AdaptiveAvgPool2DBackward");
  static PyTypeObject AdaptiveAvgPool3DBackwardClass;
  addClass<AdaptiveAvgPool3DBackward>(AdaptiveAvgPool3DBackwardClass, "AdaptiveAvgPool3DBackward");
  static PyTypeObject AdaptiveMaxPool2DBackwardClass;
  addClass<AdaptiveMaxPool2DBackward>(AdaptiveMaxPool2DBackwardClass, "AdaptiveMaxPool2DBackward");
  static PyTypeObject AdaptiveMaxPool3DBackwardClass;
  addClass<AdaptiveMaxPool3DBackward>(AdaptiveMaxPool3DBackwardClass, "AdaptiveMaxPool3DBackward");
  static PyTypeObject AvgPool2DBackwardClass;
  addClass<AvgPool2DBackward>(AvgPool2DBackwardClass, "AvgPool2DBackward");
  static PyTypeObject AvgPool3DBackwardClass;
  addClass<AvgPool3DBackward>(AvgPool3DBackwardClass, "AvgPool3DBackward");
  static PyTypeObject FractionalMaxPool2DBackwardClass;
  addClass<FractionalMaxPool2DBackward>(FractionalMaxPool2DBackwardClass, "FractionalMaxPool2DBackward");
  static PyTypeObject MaxPool2DWithIndicesBackwardClass;
  addClass<MaxPool2DWithIndicesBackward>(MaxPool2DWithIndicesBackwardClass, "MaxPool2DWithIndicesBackward");
  static PyTypeObject MaxPool3DWithIndicesBackwardClass;
  addClass<MaxPool3DWithIndicesBackward>(MaxPool3DWithIndicesBackwardClass, "MaxPool3DWithIndicesBackward");
  static PyTypeObject MaxUnpool2DBackwardClass;
  addClass<MaxUnpool2DBackward>(MaxUnpool2DBackwardClass, "MaxUnpool2DBackward");
  static PyTypeObject MaxUnpool3DBackwardClass;
  addClass<MaxUnpool3DBackward>(MaxUnpool3DBackwardClass, "MaxUnpool3DBackward");
  static PyTypeObject ThnnBatchNormBackwardClass;
  addClass<ThnnBatchNormBackward>(ThnnBatchNormBackwardClass, "ThnnBatchNormBackward");
  static PyTypeObject ThnnBatchNormBackwardBackwardClass;
  addClass<ThnnBatchNormBackwardBackward>(ThnnBatchNormBackwardBackwardClass, "ThnnBatchNormBackwardBackward");
  static PyTypeObject ThnnConvTranspose2DBackwardClass;
  addClass<ThnnConvTranspose2DBackward>(ThnnConvTranspose2DBackwardClass, "ThnnConvTranspose2DBackward");
  static PyTypeObject ThnnConvTranspose2DBackwardBackwardClass;
  addClass<ThnnConvTranspose2DBackwardBackward>(ThnnConvTranspose2DBackwardBackwardClass, "ThnnConvTranspose2DBackwardBackward");
  static PyTypeObject ThnnConvTranspose3DBackwardClass;
  addClass<ThnnConvTranspose3DBackward>(ThnnConvTranspose3DBackwardClass, "ThnnConvTranspose3DBackward");
  static PyTypeObject ThnnConvTranspose3DBackwardBackwardClass;
  addClass<ThnnConvTranspose3DBackwardBackward>(ThnnConvTranspose3DBackwardBackwardClass, "ThnnConvTranspose3DBackwardBackward");
  static PyTypeObject ThnnConv2DBackwardClass;
  addClass<ThnnConv2DBackward>(ThnnConv2DBackwardClass, "ThnnConv2DBackward");
  static PyTypeObject ThnnConv2DBackwardBackwardClass;
  addClass<ThnnConv2DBackwardBackward>(ThnnConv2DBackwardBackwardClass, "ThnnConv2DBackwardBackward");
  static PyTypeObject ThnnConvDepthwise2DBackwardClass;
  addClass<ThnnConvDepthwise2DBackward>(ThnnConvDepthwise2DBackwardClass, "ThnnConvDepthwise2DBackward");
  static PyTypeObject ThnnConvDepthwise2DBackwardBackwardClass;
  addClass<ThnnConvDepthwise2DBackwardBackward>(ThnnConvDepthwise2DBackwardBackwardClass, "ThnnConvDepthwise2DBackwardBackward");
  static PyTypeObject ThnnConv3DBackwardClass;
  addClass<ThnnConv3DBackward>(ThnnConv3DBackwardClass, "ThnnConv3DBackward");
  static PyTypeObject ThnnConv3DBackwardBackwardClass;
  addClass<ThnnConv3DBackwardBackward>(ThnnConv3DBackwardBackwardClass, "ThnnConv3DBackwardBackward");
  static PyTypeObject ThnnConvDilated2DBackwardClass;
  addClass<ThnnConvDilated2DBackward>(ThnnConvDilated2DBackwardClass, "ThnnConvDilated2DBackward");
  static PyTypeObject ThnnConvDilated2DBackwardBackwardClass;
  addClass<ThnnConvDilated2DBackwardBackward>(ThnnConvDilated2DBackwardBackwardClass, "ThnnConvDilated2DBackwardBackward");
  static PyTypeObject ThnnConvDilated3DBackwardClass;
  addClass<ThnnConvDilated3DBackward>(ThnnConvDilated3DBackwardClass, "ThnnConvDilated3DBackward");
  static PyTypeObject ThnnConvDilated3DBackwardBackwardClass;
  addClass<ThnnConvDilated3DBackwardBackward>(ThnnConvDilated3DBackwardBackwardClass, "ThnnConvDilated3DBackwardBackward");
  static PyTypeObject AdaptiveAvgPool2DBackwardBackwardClass;
  addClass<AdaptiveAvgPool2DBackwardBackward>(AdaptiveAvgPool2DBackwardBackwardClass, "AdaptiveAvgPool2DBackwardBackward");
  static PyTypeObject AdaptiveAvgPool3DBackwardBackwardClass;
  addClass<AdaptiveAvgPool3DBackwardBackward>(AdaptiveAvgPool3DBackwardBackwardClass, "AdaptiveAvgPool3DBackwardBackward");
  static PyTypeObject AdaptiveMaxPool2DBackwardBackwardClass;
  addClass<AdaptiveMaxPool2DBackwardBackward>(AdaptiveMaxPool2DBackwardBackwardClass, "AdaptiveMaxPool2DBackwardBackward");
  static PyTypeObject AdaptiveMaxPool3DBackwardBackwardClass;
  addClass<AdaptiveMaxPool3DBackwardBackward>(AdaptiveMaxPool3DBackwardBackwardClass, "AdaptiveMaxPool3DBackwardBackward");
  static PyTypeObject AvgPool2DBackwardBackwardClass;
  addClass<AvgPool2DBackwardBackward>(AvgPool2DBackwardBackwardClass, "AvgPool2DBackwardBackward");
  static PyTypeObject AvgPool3DBackwardBackwardClass;
  addClass<AvgPool3DBackwardBackward>(AvgPool3DBackwardBackwardClass, "AvgPool3DBackwardBackward");
  static PyTypeObject EluBackwardBackwardClass;
  addClass<EluBackwardBackward>(EluBackwardBackwardClass, "EluBackwardBackward");
  static PyTypeObject FractionalMaxPool2DBackwardBackwardClass;
  addClass<FractionalMaxPool2DBackwardBackward>(FractionalMaxPool2DBackwardBackwardClass, "FractionalMaxPool2DBackwardBackward");
  static PyTypeObject GluBackwardBackwardClass;
  addClass<GluBackwardBackward>(GluBackwardBackwardClass, "GluBackwardBackward");
  static PyTypeObject HardtanhBackwardBackwardClass;
  addClass<HardtanhBackwardBackward>(HardtanhBackwardBackwardClass, "HardtanhBackwardBackward");
  static PyTypeObject KlDivBackwardBackwardClass;
  addClass<KlDivBackwardBackward>(KlDivBackwardBackwardClass, "KlDivBackwardBackward");
  static PyTypeObject L1LossBackwardBackwardClass;
  addClass<L1LossBackwardBackward>(L1LossBackwardBackwardClass, "L1LossBackwardBackward");
  static PyTypeObject LogSigmoidBackwardBackwardClass;
  addClass<LogSigmoidBackwardBackward>(LogSigmoidBackwardBackwardClass, "LogSigmoidBackwardBackward");
  static PyTypeObject LogSoftmaxBackwardDataBackwardClass;
  addClass<LogSoftmaxBackwardDataBackward>(LogSoftmaxBackwardDataBackwardClass, "LogSoftmaxBackwardDataBackward");
  static PyTypeObject LeakyReluBackwardBackwardClass;
  addClass<LeakyReluBackwardBackward>(LeakyReluBackwardBackwardClass, "LeakyReluBackwardBackward");
  static PyTypeObject MaxPool2DWithIndicesBackwardBackwardClass;
  addClass<MaxPool2DWithIndicesBackwardBackward>(MaxPool2DWithIndicesBackwardBackwardClass, "MaxPool2DWithIndicesBackwardBackward");
  static PyTypeObject MaxPool3DWithIndicesBackwardBackwardClass;
  addClass<MaxPool3DWithIndicesBackwardBackward>(MaxPool3DWithIndicesBackwardBackwardClass, "MaxPool3DWithIndicesBackwardBackward");
  static PyTypeObject MaxUnpool2DBackwardBackwardClass;
  addClass<MaxUnpool2DBackwardBackward>(MaxUnpool2DBackwardBackwardClass, "MaxUnpool2DBackwardBackward");
  static PyTypeObject MseLossBackwardBackwardClass;
  addClass<MseLossBackwardBackward>(MseLossBackwardBackwardClass, "MseLossBackwardBackward");
  static PyTypeObject NllLossBackwardBackwardClass;
  addClass<NllLossBackwardBackward>(NllLossBackwardBackwardClass, "NllLossBackwardBackward");
  static PyTypeObject NllLoss2DBackwardBackwardClass;
  addClass<NllLoss2DBackwardBackward>(NllLoss2DBackwardBackwardClass, "NllLoss2DBackwardBackward");
  static PyTypeObject PreluBackwardBackwardClass;
  addClass<PreluBackwardBackward>(PreluBackwardBackwardClass, "PreluBackwardBackward");
  static PyTypeObject RreluWithNoiseBackwardBackwardClass;
  addClass<RreluWithNoiseBackwardBackward>(RreluWithNoiseBackwardBackwardClass, "RreluWithNoiseBackwardBackward");
  static PyTypeObject ReflectionPad1DBackwardBackwardClass;
  addClass<ReflectionPad1DBackwardBackward>(ReflectionPad1DBackwardBackwardClass, "ReflectionPad1DBackwardBackward");
  static PyTypeObject ReflectionPad2DBackwardBackwardClass;
  addClass<ReflectionPad2DBackwardBackward>(ReflectionPad2DBackwardBackwardClass, "ReflectionPad2DBackwardBackward");
  static PyTypeObject ReplicationPad1DBackwardBackwardClass;
  addClass<ReplicationPad1DBackwardBackward>(ReplicationPad1DBackwardBackwardClass, "ReplicationPad1DBackwardBackward");
  static PyTypeObject ReplicationPad2DBackwardBackwardClass;
  addClass<ReplicationPad2DBackwardBackward>(ReplicationPad2DBackwardBackwardClass, "ReplicationPad2DBackwardBackward");
  static PyTypeObject ReplicationPad3DBackwardBackwardClass;
  addClass<ReplicationPad3DBackwardBackward>(ReplicationPad3DBackwardBackwardClass, "ReplicationPad3DBackwardBackward");
  static PyTypeObject SmoothL1LossBackwardBackwardClass;
  addClass<SmoothL1LossBackwardBackward>(SmoothL1LossBackwardBackwardClass, "SmoothL1LossBackwardBackward");
  static PyTypeObject SoftplusBackwardBackwardClass;
  addClass<SoftplusBackwardBackward>(SoftplusBackwardBackwardClass, "SoftplusBackwardBackward");
  static PyTypeObject SoftmaxBackwardDataBackwardClass;
  addClass<SoftmaxBackwardDataBackward>(SoftmaxBackwardDataBackwardClass, "SoftmaxBackwardDataBackward");
  static PyTypeObject SoftMarginLossBackwardBackwardClass;
  addClass<SoftMarginLossBackwardBackward>(SoftMarginLossBackwardBackwardClass, "SoftMarginLossBackwardBackward");
  static PyTypeObject SoftshrinkBackwardBackwardClass;
  addClass<SoftshrinkBackwardBackward>(SoftshrinkBackwardBackwardClass, "SoftshrinkBackwardBackward");
  static PyTypeObject ThresholdBackwardBackwardClass;
  addClass<ThresholdBackwardBackward>(ThresholdBackwardBackwardClass, "ThresholdBackwardBackward");
  static PyTypeObject UpsampleLinear1DBackwardBackwardClass;
  addClass<UpsampleLinear1DBackwardBackward>(UpsampleLinear1DBackwardBackwardClass, "UpsampleLinear1DBackwardBackward");
  static PyTypeObject UpsampleBilinear2DBackwardBackwardClass;
  addClass<UpsampleBilinear2DBackwardBackward>(UpsampleBilinear2DBackwardBackwardClass, "UpsampleBilinear2DBackwardBackward");
  static PyTypeObject UpsampleTrilinear3DBackwardBackwardClass;
  addClass<UpsampleTrilinear3DBackwardBackward>(UpsampleTrilinear3DBackwardBackwardClass, "UpsampleTrilinear3DBackwardBackward");
  static PyTypeObject UpsampleNearest1DBackwardBackwardClass;
  addClass<UpsampleNearest1DBackwardBackward>(UpsampleNearest1DBackwardBackwardClass, "UpsampleNearest1DBackwardBackward");
  static PyTypeObject UpsampleNearest2DBackwardBackwardClass;
  addClass<UpsampleNearest2DBackwardBackward>(UpsampleNearest2DBackwardBackwardClass, "UpsampleNearest2DBackwardBackward");
  static PyTypeObject UpsampleNearest3DBackwardBackwardClass;
  addClass<UpsampleNearest3DBackwardBackward>(UpsampleNearest3DBackwardBackwardClass, "UpsampleNearest3DBackwardBackward");
  static PyTypeObject SigmoidBackwardBackwardClass;
  addClass<SigmoidBackwardBackward>(SigmoidBackwardBackwardClass, "SigmoidBackwardBackward");
  static PyTypeObject TanhBackwardBackwardClass;
  addClass<TanhBackwardBackward>(TanhBackwardBackwardClass, "TanhBackwardBackward");
  static PyTypeObject CudnnConvolutionTransposeBackwardClass;
  addClass<CudnnConvolutionTransposeBackward>(CudnnConvolutionTransposeBackwardClass, "CudnnConvolutionTransposeBackward");
  static PyTypeObject CudnnConvolutionTransposeBackwardBackwardClass;
  addClass<CudnnConvolutionTransposeBackwardBackward>(CudnnConvolutionTransposeBackwardBackwardClass, "CudnnConvolutionTransposeBackwardBackward");
  static PyTypeObject CudnnConvolutionBackwardClass;
  addClass<CudnnConvolutionBackward>(CudnnConvolutionBackwardClass, "CudnnConvolutionBackward");
  static PyTypeObject CudnnConvolutionBackwardBackwardClass;
  addClass<CudnnConvolutionBackwardBackward>(CudnnConvolutionBackwardBackwardClass, "CudnnConvolutionBackwardBackward");
  static PyTypeObject CudnnGridSamplerBackwardClass;
  addClass<CudnnGridSamplerBackward>(CudnnGridSamplerBackwardClass, "CudnnGridSamplerBackward");
  static PyTypeObject CudnnAffineGridGeneratorBackwardClass;
  addClass<CudnnAffineGridGeneratorBackward>(CudnnAffineGridGeneratorBackwardClass, "CudnnAffineGridGeneratorBackward");
  static PyTypeObject CudnnBatchNormBackwardClass;
  addClass<CudnnBatchNormBackward>(CudnnBatchNormBackwardClass, "CudnnBatchNormBackward");
  static PyTypeObject CudnnBatchNormBackwardBackwardClass;
  addClass<CudnnBatchNormBackwardBackward>(CudnnBatchNormBackwardBackwardClass, "CudnnBatchNormBackwardBackward");
  static PyTypeObject CudnnRnnBackwardClass;
  addClass<CudnnRnnBackward>(CudnnRnnBackwardClass, "CudnnRnnBackward");
  static PyTypeObject MkldnnConvolutionBackwardClass;
  addClass<MkldnnConvolutionBackward>(MkldnnConvolutionBackwardClass, "MkldnnConvolutionBackward");
  static PyTypeObject FftWithSizeBackwardClass;
  addClass<FftWithSizeBackward>(FftWithSizeBackwardClass, "FftWithSizeBackward");
  static PyTypeObject UnbindBackwardClass;
  addClass<UnbindBackward>(UnbindBackwardClass, "UnbindBackward");
  static PyTypeObject StackBackwardClass;
  addClass<StackBackward>(StackBackwardClass, "StackBackward");
}

}}} // namespace torch::autograd::generated
